using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Globalization;
using Microsoft.Web.Script.Serialization;
using System.Collections.Generic;

namespace Jeffz.TypeConverterDemoTypes
{
	[TypeConverter(typeof(EmployeeConverter))]
	public class Employee
	{
		public string Name;

		public int Age;
	}

	public class EmployeeConverter : TypeConverter
	{
		public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
		{
			if (sourceType == typeof(String))
			{
				return true;
			}

			return false;
		}

		public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
		{
			IDictionary<string, object> dictObj = 
				JavaScriptObjectDeserializer.DeserializeDictionary(value.ToString());

			Employee emp = new Employee();
			emp.Name = dictObj["Name"].ToString();
			emp.Age = (int)dictObj["Age"];

			return emp;
		}
	}
}
